﻿Type=Class
Version=5.51
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	
	Private c_ListWithMaps As List
	Private c_ListView1 As ListView
	Private c_itemlayout As String
	Private c_LinkKey As String
	
	Dim ImageView1 As ImageView
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
'Provide a list containing maps.
'One of the key's within the map should contain a link - specify the keyname as linkkey.
'The remaining keys will be matched to the label ID's of the FX Scene. The label.text will be updated with the value of the keymap.
'ItemLayout is the FXML document name.
'LinkKey is the name of the key containing the image link 
Public Sub Initialize(l As List, ItemLayout As String, LinkKey As String)

	c_ListWithMaps.Initialize
	c_ListView1.Initialize("listView1")
	
	c_ListWithMaps=l
	c_itemlayout = ItemLayout
	c_LinkKey=LinkKey
	
End Sub

Public Sub CreateListview() As ListView
	
	BuildItems(c_ListWithMaps)
	
	Return c_ListView1
	
End Sub

Public Sub UpdateListView(l As List, view As ListView) As ListView
	
	c_ListWithMaps=l
	c_ListView1=view
	BuildItems(c_ListWithMaps)
	
	Return c_ListView1
	
End Sub

Private Sub  BuildItems (links As List)
	
	Dim DownloadMap As Map
	DownloadMap.Initialize
	
	c_ListView1.Items.Clear
	
	For Each m As Object In c_ListWithMaps
		
		'the list may contain other types which we don't need now.
		
		If m Is Map Then
			
			Dim m1 As Map = m
			Dim link As String
			Dim p As AnchorPane
		
			'init
			p.Initialize("")
			p.LoadLayout(c_itemlayout)
		
			'get link
			link = m1.Get(c_LinkKey)
		
			'iterate through the remainder of the keys within the map
			For Each k As String In m1.Keys
				'ignore the link key as we already processed that! and loop through ALL nodes
				If k <> c_LinkKey Then
					For Each n As Node In p.GetAllViewsRecursive
						'check if the found node is a label and the key matches the id set to the label
						If n Is Label And n.Id = k Then
							'set the textvalue to the label
							Dim label1 As Label = n
							label1.Text=m1.Get(k)
							n=label1
						End If
					Next
				End If
			Next
		
			'Add the

			c_ListView1.Items.Add(p)

			DownloadMap.Put(ImageView1, link)
		End If
	Next
	

	'download the images
	Dim id As ImageDownloader
	id.Initialize
	id.Download(DownloadMap)
	

End Sub