﻿Type=Class
Version=5.51
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@

Sub Class_Globals
	Private cache As Map
	Private tasks As Map
	Private ongoingTasks As Map
End Sub

Public Sub Initialize
	tasks.Initialize
	cache.Initialize
	ongoingTasks.Initialize
End Sub


Public Sub Download (ImageViewsMap As Map)
	For i = 0 To ImageViewsMap.Size - 1
		tasks.Put(ImageViewsMap.GetKeyAt(i), ImageViewsMap.GetValueAt(i))
		Dim link As String = ImageViewsMap.GetValueAt(i)
		If cache.ContainsKey(link) Then
			
			Dim iv As ImageView = ImageViewsMap.GetKeyAt(i)
			iv.SetImage(cache.Get(link))
			
		Else If ongoingTasks.ContainsKey(link) = False Then
			

				ongoingTasks.Put(link, "")
				Dim j As HttpJob
				j.Initialize(link, Me)
				j.Download(link)

		End If
	Next
End Sub

Sub JobDone(Job As HttpJob)
	ongoingTasks.Remove(Job.JobName)
	If Job.Success Then
		Dim bmp As Image = Job.GetBitmap
		cache.Put(Job.JobName, bmp)
		If tasks.IsInitialized Then
			For i = 0 To tasks.Size - 1
				Dim link As String = tasks.GetValueAt(i)
				If link = Job.JobName Then
					Dim iv As ImageView = tasks.GetKeyAt(i)
					iv.SetImage(bmp)
				End If
			Next
		End If
	Else
		Log("Error downloading image: " & Job.JobName & CRLF & Job.ErrorMessage)
	End If
	If ongoingTasks.Size = 0 Then tasks.Clear
	Job.Release
End Sub

